#include "pc6001v.h"
#include "movie.h"
#include "common.h"


// [] MSDN
// AVI ե եޥå
// http://msdn.microsoft.com/library/ja/default.asp?url=/library/ja/directx9_c/directx/htm/avifileformat.asp
// AVI ե եޥåȤ DV ǡ(֥ƥ)
// http://msdn.microsoft.com/library/ja/default.asp?url=/library/ja/jpdx8_c/ds/filtdev/DV_Data_AVI_File_Format.asp

// 16bit⡼ɤˤĤƤΥ
// SDL R:G:B=5:6:5 餷ΤΥեޥåȤQuickTimeǾ꤯Ǥʤ褦ʤΤ
// R:G:B=5:5:5 ȤƤߤ롣

#define	CIDVIDS		(CTODW( 'v', 'i', 'd', 's' ))
#define	CIDAUDS		(CTODW( 'a', 'u', 'd', 's' ))
#define	CIDRLE		(CTODW( 'R', 'L', 'E', ' ' ))
#define	CIDDIB		(CTODW( 'D', 'I', 'B', ' ' ))
#define	CID00DC		(CTODW( '0', '0', 'd', 'c' ))
#define	CID00DB		(CTODW( '0', '0', 'd', 'b' ))
#define	CID01WB		(CTODW( '0', '1', 'w', 'b' ))


////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
AVI6::AVI6( void )
{
	vfp  = NULL;
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
AVI6::~AVI6( void )
{
	if( IsAVI() ) StopAVI();
}


////////////////////////////////////////////////////////////////
// Ƽإå
////////////////////////////////////////////////////////////////
void AVI6::putBMPINFOHEADER6( BMPINFOHEADER6 *p )
{
	FPUTDWORD( p->biSize,			vfp );
	FPUTDWORD( p->biWidth,			vfp );	// LONG
	FPUTDWORD( p->biHeight,			vfp );	// LONG
	FPUTWORD(  p->biPlanes,			vfp );
	FPUTWORD(  p->biBitCount,		vfp );
	FPUTDWORD( p->biCompression,	vfp );
	FPUTDWORD( p->biSizeImage,		vfp );
	FPUTDWORD( p->biXPelsPerMeter,	vfp );	// LONG
	FPUTDWORD( p->biYPelsPerMeter,	vfp );	// LONG
	FPUTDWORD( p->biClrUsed,		vfp );
	FPUTDWORD( p->biClrImportant,	vfp );
}

void AVI6::putMAINAVIHEADER6( MAINAVIHEADER6 *p )
{
	FPUTDWORD( p->dwMicroSecPerFrame,		vfp );
	FPUTDWORD( p->dwMaxBytesPerSec,			vfp );
	FPUTDWORD( p->dwReserved1,				vfp );
	FPUTDWORD( p->dwFlags,					vfp );
	FPUTDWORD( p->dwTotalFrames,			vfp );
	FPUTDWORD( p->dwInitialFrames,			vfp );
	FPUTDWORD( p->dwStreams,				vfp );
	FPUTDWORD( p->dwSuggestedBufferSize,	vfp );
	FPUTDWORD( p->dwWidth,					vfp );
	FPUTDWORD( p->dwHeight,					vfp );
	fwrite( (DWORD *)&p->dwReserved ,sizeof(DWORD), 4, vfp );
}

void AVI6::putAVISTRMHEADER6( AVISTRMHEADER6 *p )
{
	FPUTDWORD( p->fccType,					vfp );
	FPUTDWORD( p->fccHandler,				vfp );
	FPUTDWORD( p->dwFlags,					vfp );
	FPUTDWORD( p->dwPriority,				vfp );
	FPUTDWORD( p->dwInitialFrames,			vfp );
	FPUTDWORD( p->dwScale,					vfp );
	FPUTDWORD( p->dwRate,					vfp );
	FPUTDWORD( p->dwStart,					vfp );
	FPUTDWORD( p->dwLength,					vfp );
	FPUTDWORD( p->dwSuggestedBufferSize,	vfp );
	FPUTDWORD( p->dwQuality,				vfp );
	FPUTDWORD( p->dwSampleSize,				vfp );
	
	FPUTDWORD( p->rcFrame.left,		vfp );	// LONG
	FPUTDWORD( p->rcFrame.top,		vfp );	// LONG
	FPUTDWORD( p->rcFrame.right,	vfp );	// LONG
	FPUTDWORD( p->rcFrame.bottom,	vfp );	// LONG
}

// AVIINDEXENTRY
void AVI6::putAVIINDEXENTRY6( AVIINDEXENTRY6 *p )
{
	FPUTDWORD( p->ckid,				vfp );
	FPUTDWORD( p->dwFlags,			vfp );
	FPUTDWORD( p->dwChunkOffset,	vfp );
	FPUTDWORD( p->dwChunkLength,	vfp );
} 

// WAVEFORMATEX
void AVI6::putWAVEFORMATEX6( WAVEFORMATEX6 *p )
{
	FPUTWORD( p->wFormatTag,		vfp );
	FPUTWORD( p->nChannels,			vfp );
	FPUTDWORD(p->nSamplesPerSec,	vfp );
	FPUTDWORD(p->nAvgBytesPerSec,	vfp );
	FPUTWORD( p->nBlockAlign,		vfp );
	FPUTWORD( p->wBitsPerSample,	vfp );
	FPUTWORD( p->cbSize,			vfp );
	
	FPUTWORD( 0,            		vfp );
}




////////////////////////////////////////////////////////////////
// 
//
// :	ʤ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL AVI6::Init( void )
{
	PRINTD( GRP_LOG, "[MOVIE][Init]\n" );
	
	if( vfp ) fclose( vfp );
	vfp = NULL;
	
	memset( &vmh, 0, sizeof(MAINAVIHEADER6) );
	memset( &vsh, 0, sizeof(AVISTRMHEADER6) );
	memset( &ash, 0, sizeof(AVISTRMHEADER6) );
	memset( &vbf, 0, sizeof(BMPINFOHEADER6) );
	memset( &pal, 0, sizeof(RGBPAL6)*256 );
	memset( &awf, 0, sizeof(WAVEFORMATEX6) );
	
	ABPP     = 8;
	AVIRLE   = TRUE;
	
	PosMOVI  = 0;
	
	RiffSize = 0;
	MoviSize = 0;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ӥǥץ㳫
//
// :	filename	ϥե̾
//			w			
//			h			ι⤵
//			vrate		ե졼졼(fps)
//			arate		ץ󥰥졼(Hz)
//			bpp			Bits per Pixcel 8:8bit 24:24bit
//			rle			TRUE:RLEȤ FALSE:RLEȤʤ
// :	BOOL		TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL AVI6::StartAVI( char *filename, int w, int h, int vrate, int arate, int bpp, BOOL rle )
{
	Init();
	
	vfp = FOPENEN( filename, "w+b" );
	if( !vfp ) return FALSE;
	
	switch( bpp ){
	case 24: ABPP = 24; AVIRLE = FALSE; break;
	case 16: ABPP = 16; AVIRLE = FALSE; break;
	default: ABPP =  8; AVIRLE = rle;
	}
	
	// AVIᥤإå
	// ե졼֤δֳ֤ޥñ̤ǻꤹ롣ͤϥեΤΥߥ󥰤򼨤
	vmh.dwMicroSecPerFrame = 1000000 / vrate;
	// եγǡ졼Ȥꤹ롣ͤ,ᥤإåӥȥ꡼إå󥯤˴ޤޤ
	// ¾Υѥ᡼˽ä AVI󥹤ɽ뤿,ƥबʤФʤʤäΥХȿ򼨤
	// (Ȥꤢ̵)
	vmh.dwMaxBytesPerSec = 0;
	// եФե饰ޤࡣʲΥե饰Ƥ롣
	//  AVIF_HASINDEX AVI	եν˥ǥåޤ 'idx1'󥯤뤳Ȥ򼨤
	//						ɹʥѥեޥ󥹤Τˤ,٤Ƥ AVIե뤬ǥåޤɬפ롣
	//  AVIF_MUSTUSEINDEX	ǡΥץ쥼ơνꤹ뤿,եΥ󥯤ʪŪʽǤϤʤ
	//						ǥåѤ뤳Ȥ򼨤Ȥ,Ȥäƥե졼ΥꥹȤԽ뤳ȤǤ롣
	//  AVIF_ISINTERLEAVED	AVIե뤬󥿡꡼֤Ƥ뤳Ȥ򼨤
	//  AVIF_WASCAPTUREFILE	AVIե뤬,ꥢ륿ӥǥΥץѤ̤˳Ƥ줿եǤ뤳Ȥ򼨤
	//						ץꥱ,Υե饰ꤵ줿ե򥪡С饤ɤ,桼˷ٹȯɬפ롣
	//						,桼Υեǥե饰ȤƤǽ⤤Ǥ롣
	//  AVIF_COPYRIGHTED	AVIեΤǡӥեȥޤޤƤ뤳Ȥ򼨤
	//						Υե饰ѤƤ,եȥϥǡʣĤ٤ǤϤʤ
	vmh.dwFlags = 0x00000010;	// AVIF_HASINDEX
	// եΥǡΥե졼ꤹ롣
	// ()
	vmh.dwTotalFrames = 0;
	// 󥿡꡼֤줿եγϥե졼ꤹ롣󥿡꡼֤줿եʳǤ,ꤹ롣
	// 󥿡꡼֤줿ե,ե AVI󥹤γϥե졼ˤե졼
	// ΥФ˻ꤹ롣ΥФƤ˴ؤܺ٤ˤĤƤ
	// Video for Windows Programmer's Guide٤ΡSpecial Information for Interleaved Filesפ򻲾Ȥ뤳ȡ
	vmh.dwInitialFrames = 0;
	// եΥȥ꡼ꤹ롣Ȥ,ǥȥӥǥޤեˤ 2ĤΥȥ꡼ब롣
	vmh.dwStreams = 2;
	// եɤ߼뤿ΥХåեꤹ롣̤,ΥϥեκΥ󥯤ǼΤ
	// ʬ礭ˤ롣ꤷ,ͤꤷ,եȥϺ˥
	// ƳƤʤФʤ餺,ѥեޥ󥹤㲼롣󥿡꡼֤줿եξ,Хåեϥ󥯤ǤϤʤ
	// 쥳Τɤ߼Τ˽ʬ礭ǤʤФʤʤ
	// (Ȥꤢ1ե졼ʬ)
	vmh.dwSuggestedBufferSize = w * h * ( ABPP / 8 );
	// AVIեԥñ̤ǻꤹ롣
	vmh.dwWidth  = w;
	// AVIեι⤵ԥñ̤ǻꤹ롣
	vmh.dwHeight = h;
	
	// AVIȥ꡼إå
	// ȥ꡼˴ޤޤǡΥפꤹ FOURCC ޤࡣӥǥӥǥФưʲɸAVIͤƤ롣
	//  'vids'	ȥ꡼˥ӥǥǡޤޤ뤳Ȥ򼨤ȥ꡼եޥåȥ󥯤ˤ,ѥåȾޤळȤǽ
	//			BITMAPINFO ¤Τޤޤ롣
	//  'auds'	ȥ꡼˥ǥǡޤޤ뤳Ȥ򼨤ȥ꡼եޥåȥ󥯤ˤ,WAVEFORMATEX
	//			ޤ PCMWAVEFORMAT ¤Τޤޤ롣
	//  'txts'	ȥ꡼˥ƥ ǡޤޤ뤳Ȥ򼨤
	vsh.fccType = CIDVIDS;
	ash.fccType = CIDAUDS;
	// Υǡϥɥ򼨤 FOURCC ޤ (ץ)ǡϥɥ,ȥ꡼ФŬڤʥϥɥǤ롣
	// ǥӥӥǥȥ꡼ξ,󥹥ȡǽʥץåޤϥǥץåꤹ롣
	vsh.fccHandler = ( (ABPP==8) && AVIRLE ) ? CIDRLE  : CIDDIB;
	ash.fccHandler = 0x00000001;	//(PCM)
	// ǡ ȥ꡼Фե饰ޤࡣΥե饰ξ̥ɤΥӥåȤ,ȥ꡼˴ޤޤǡΥפ˸ͭǤ롣
	// ʲɸե饰Ƥ롣
	//  AVISF_DISABLED			Υȥ꡼ǥեȤͭˤʤȤ򼨤
	//  AVISF_VIDEO_PALCHANGES	Υӥǥȥ꡼˥ѥåȤѹޤޤ뤳Ȥ򼨤Υե饰,եȥФ
	//							ѥåȤ򥢥˥᡼󤹤ɬפ뤳Ȥٹ𤹤롣
	vsh.dwFlags = 0;
	ash.dwFlags = 0;
	// ȥ꡼ פ̤ͥꤹ롣Ȥ,ʣΥǥȥ꡼ޤեǤ,̤ͥκǤ⤤ȥ꡼ब
	// ǥեȤΥȥ꡼ˤʤ롣
	vsh.dwPriority = 0;
	ash.dwPriority = 0;
	// 󥿡꡼֤줿ե,ǥǡӥǥե졼फɤΤ餤塼Ƥ뤫ꤹ롣
	// ̾, 0.75 äǤ롣󥿡꡼֤줿ե,ե AVI󥹤γϥե졼
	// ˤե졼,ΥФ˻ꤹ롣ΥФƤ˴ؤܺ٤ˤĤƤ,Video for Windows Programmer's Guide٤
	// Special Information for Interleaved Filesפ򻲾Ȥ뤳ȡ
	vsh.dwInitialFrames = 0;
	ash.dwInitialFrames = 0;
	// dwRate ȤȤ˻Ѥ,Υȥ꡼बѤ륿ॹꤹ롣dwRate  dwScale ǳ뤳Ȥˤ
	// 1 äΥץ롣ӥǥȥ꡼ξ,Υ졼Ȥϥե졼졼Ȥʤ롣
	// ǥȥ꡼ξ,Υ졼Ȥ nBlockAlign ХȤΥǥǡɬפʻ֤б롣
	//  PCMǥξϥץ졼Ȥʤ롣
	vsh.dwScale = 10000;
	ash.dwScale = 2;
	// dwScale 򻲾Ȥ뤳ȡ
	vsh.dwRate = vsh.dwScale * vrate;
	ash.dwRate = ash.dwScale * arate;
	// AVIեγϥꤹ롣ñ̤,ᥤեإå dwRate  dwScale Фˤä롣
	// ̾,ϥǤ뤬,եƱ˳Ϥʤȥ꡼ФƤ,ٱ֤ꤹ뤳ȤǤ롣
	vsh.dwStart = 0;
	ash.dwStart = 0;
	// Υȥ꡼Ĺꤹ롣ñ̤,ȥ꡼Υإå dwRate  dwScale Фˤä롣
	// ()
	vsh.dwLength = 0;
	ash.dwLength = 0;
	// Υȥ꡼ɤ߼뤿ɬפʥХåե礭ꤹ롣̾,ȥ꡼κΥ󥯤бͤǤ롣
	// ХåեѤ뤳Ȥ,θΨޤ롣Хåե狼ʤ,ꤹ롣
	// (Ȥꤢ1ե졼ʬ)
	vsh.dwSuggestedBufferSize = w * h * ( ABPP / 8 );
	ash.dwSuggestedBufferSize = arate / vrate * 2;
	// ȥ꡼Υǡʼ򼨤ͤꤹ롣ʼ,010,000 ϰϤͤǼ롣̥ǡξ,̾
	// ̥եȥϤʼѥ᡼ͤ򼨤-1ꤷ,ɥ饤ФϥǥեȤʼͤѤ롣
	vsh.dwQuality = 0;
	ash.dwQuality = 0;
	// ǡ 1 ץΥꤹ롣ץΥѲ,ꤹ롣ͤǤʤ
	// եʣΥǡץ 1ĤΥ󥯤˥롼ײǤ롣ξ,ƥǡץ(ӥǥե졼ʤ)
	// Ϥ줾̤Υ󥯤˴ޤޤʤФʤʤӥǥȥ꡼ξ,ͤ̾良Ǥ뤬
	// ٤ƤΥӥǥե졼बƱǤ,ʳͤˤǤ롣ǥȥ꡼ξ,ͤϥǥ
	// Ҥ WAVEFORMATEX ¤Τ nBlockAlign ФƱǤʤФʤʤ
	vsh.dwSampleSize = 0;
	ash.dwSampleSize = 2;
	// AVI ᥤإå¤Τ dwWidth  dwHeight ФˤäƻꤵưΥƥȤޤϥӥǥȥ꡼
	// Фžꤹ롣̾,rcFrame Ф,ʣΥӥǥȥ꡼򥵥ݡȤ뤿˻Ѥ롣ζ
	// ưбɸꤷ,ưΤ򹹿롣ΥФñ̤ϥԥǤ롣žκ
	// ưκлȤʤ롣
	vsh.rcFrame.left   = 0;
	vsh.rcFrame.top    = 0;
	vsh.rcFrame.right  = w - 1;
	vsh.rcFrame.bottom = h - 1;
	
	// BMPINFOHEADER6¤Τ
	// ¤ΤɬפȤХȿꤹ롣
	vbf.biSize = sizeof(BMPINFOHEADER6);
	// ӥåȥޥåפԥñ̤ǻꤹ롣
	vbf.biWidth  = w;
	// ӥåȥޥåפι⤵ԥñ̤ǻꤹ롣biHeight ͤǤ,ӥåȥޥåפϥܥȥॢåDIB
	// (device-independent bitmap : ǥХ˰¸ʤӥåȥޥå) Ǥ,Ȥʤ롣biHeight ͤǤ
	// ӥåȥޥåפϥȥåץDIB Ǥ,Ȥʤ롣
	vbf.biHeight = h;
	// å ǥХФ̤οꤹ롣ɬ 1 ꤹ롣
	vbf.biPlanes = 1;
	// 1 ԥ뤢Υӥåȿꤹ롣̥եޥåȤˤäƤ,ԥοǥɤ뤿ˤξɬפǤ롣
	vbf.biBitCount = ABPP;
	// ѤƤ,ޤ׵ᤵƤ밵̤Υפꤹ롣¸ΰ̥եޥåȤȿ̥եޥåȤξ
	// ΥФѤ롣
	switch( ABPP ){
	case 16:
	case 24: vbf.biCompression = 0; break;	// 0:BI_RGB
	default:
		if( AVIRLE ) vbf.biCompression = 1;	// 1:BI_RLE8
		else         vbf.biCompression = 0; // 0:BI_RGB
	}
	// ᡼ΥХñ̤ǻꤹ롣󰵽RGBӥåȥޥåפξ,0 Ǥ롣
	vbf.biSizeImage = w * h * ( ABPP / 8 );
	// ӥåȥޥåפΥåȥǥХοʿ٤ 1᡼ȥ뤢Υԥñ̤ǻꤹ롣ץꥱϤͤ
	// Ѥ,꥽롼פ椫鸽ߤΥǥХ˺ǤŬ礹ӥåȥޥåפ򤹤뤳ȤǤ롣
	vbf.biXPelsPerMeter = 0;
	// ӥåȥޥåפΥå ǥХοľ٤ 1᡼ȥ뤢Υԥñ̤ǻꤹ롣
	vbf.biYPelsPerMeter = 0;
	// 顼 ơ֥Υ顼 ǥåΤ,ӥåȥޥåǼºݤ˻Ѥ륤ǥåοꤹ롣ͤ
	// ξ,ӥåȥޥåפ,biCompression ǻꤵ밵̥⡼ɤФ,biBitCount Фͤб翧Ѥ롣
	// Macξ256Ǥʤȿʤ餷(by Ĥ&Windy)
	// Ǥ24bitλ0ˤƤʤȤȺʤߤ
	switch( ABPP ){
	case 24: vbf.biClrUsed =   0; break;
	case 16: vbf.biClrUsed =   0; break;
	default: vbf.biClrUsed = 256;
	}
	// ӥåȥޥåפɽ뤿˽פȤߤʤ륫顼ǥåꤹ롣ͤξ,٤ƤοפȤߤʤ롣
	vbf.biClrImportant = 0;
	
	// ѥåȼ
	if( ABPP == 8 ){
		// ꡼󥵡եؤΥݥ󥿼
		SDL_Surface *ssuf = SDL_GetVideoSurface();
		
		for( int i=0; i<256; i++ ){
			pal[i].b        = ssuf->format->palette->colors[i].b;
			pal[i].g        = ssuf->format->palette->colors[i].g;
			pal[i].r        = ssuf->format->palette->colors[i].r;
			pal[i].reserved = 0;
		}
	}
	
	// WAVEFORMATEX6¤Τ
	// ǥȥ꡼Υǥȷפ롣եޥåȥδʥꥹȤ,Microsoft Visual C++ 
	// ¾ Microsoft ʤ° Mmreg.h إå եˤ롣
	awf.wFormatTag = 0x0001;	// WAVE_FORMAT_PCM
	// ǥȥ꡼Υͥꤹ롣1ϥ,2ϥƥ쥪򼨤
	awf.nChannels = 1;
	// ǥȥ꡼Υץ졼ȼȿ򥵥ץ/ (Hz) ǻꤹ롣Ȥ,11,025,22,050,ޤ 44,100
	awf.nSamplesPerSec = arate;
	// ʿѥǡ졼Ȥꤹ롣եȥϤͤȤäƥХåեѤ뤳ȤǤ롣
	awf.nAvgBytesPerSec = arate * 2;
	// ǡΥ֥å 饤ȤХñ̤ǻꤹ롣եȥ 1˽ǡΥХȿ
	// nBlockAlign ܤǤʤФʤʤ,nBlockAlign ͤѤƥХåեΥ饤ȤԤȤǤ롣
	awf.nBlockAlign = 2;
	// ͥǡȤ 1ץ뤢Υӥåȿꤹ롣ƥͥΥץ٤ƱǤȲꤵ롣
	// Υեɤɬפʤ,ꤹ롣
	awf.wBitsPerSample = 16;
	// եޥåȥإåɲþΥХñ̤ǻꤹ롣ˤ,WAVEFORMATEX ¤ΤΥϴޤޤʤ
	// Ȥ,wFormatTag WAVE_FORMAT_IMA_ADPCM б waveեޥåȤξ,cbSize 
	// sizeof(IMAADPCMWAVEFORMAT) - sizeof(WAVEFORMATEX) ȤƷ׻,̤ 2Ȥʤ롣
	awf.cbSize = 0;
	
	// إå󥯽Ф
	WriteHeader();
	
	// ǥХåե
	ABuf.InitBuffer( arate / vrate * 2 );
	// 󥿽
	anum = 0;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ӥǥץ
//
// :	ʤ
// :	ʤ
////////////////////////////////////////////////////////////////
void AVI6::StopAVI( void )
{
	if( !vfp ) return;
	
	// ե졼
	vsh.dwLength = vmh.dwTotalFrames;
	ash.dwLength = anum;
	
	// λǥեݥ󥿤ˤϤǰΤ
	fseek( vfp, 0, SEEK_END );
	
	// Movi󥯤Υ
	MoviSize = ftell( vfp ) - PosMOVI;
	
	// ǥå󥯽
	WriteIndexr();
	
	RiffSize = ftell( vfp ) - 8;
	
	// إå󥯺ƽФ
	WriteHeader();
	
	fclose( vfp );
	vfp = NULL;
}


////////////////////////////////////////////////////////////////
// ӥǥץ?
//
// :	ʤ
// :	BOOL	TRUE:ץ FALSE:Ҥ
////////////////////////////////////////////////////////////////
BOOL AVI6::IsAVI( void )
{
	return vfp ? TRUE : FALSE;
}


////////////////////////////////////////////////////////////////
// AVI1ե졼Ф
//
// :	ʤ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL AVI6::AVIWriteFrame( void )
{
	if( !vfp ) return FALSE;
	
	// ꡼󥵡եؤΥݥ󥿼
	SDL_Surface *ssuf = SDL_GetVideoSurface();
	
	int xx = min( ssuf->w, vbf.biWidth  );
	int yy = min( ssuf->h, vbf.biHeight );
	
	FPUTDWORD( ( (ABPP==8) && AVIRLE ) ? CID00DC : CID00DB, vfp );
	FPUTDWORD( vbf.biSizeImage, vfp );
	
	switch( ABPP ){
	case 8:		// 8bitξ
		if( AVIRLE ){	// RLEξ
			long fnum = 0;
			for( int y = yy - 1; y >= 0; y-- ){
				BYTE dat = ((BYTE *)ssuf->pixels)[y*ssuf->pitch];
				int num = 1;
				for( int x = 1; x < xx; x++ ){
					if( ( ((BYTE *)ssuf->pixels)[y*ssuf->pitch+x] != dat )||( num == 255 )||( x == xx - 1 ) ){
						FPUTBYTE( num, vfp );
						FPUTBYTE( dat, vfp );
						dat = ((BYTE *)ssuf->pixels)[y*ssuf->pitch+x];
						num = 1;
						fnum += 2;
					}else
						num++;
				}
				FPUTBYTE( 0, vfp );
				if( y ) FPUTBYTE( 0, vfp );
				else    FPUTBYTE( 1, vfp );
				fnum += 2;
			}
			fseek( vfp, -fnum-4, SEEK_CUR );
			FPUTDWORD( (DWORD)fnum, vfp );
			fseek( vfp, 0, SEEK_END );
		}else{			// ٥ξ
			for( int y = yy - 1; y >= 0; y-- )
				fwrite( (BYTE *)ssuf->pixels + ssuf->pitch * y, sizeof(BYTE), xx, vfp );
		}
		break;
		
	case 16:	// 16bitξ
		for( int y = yy - 1; y >= 0; y-- ){
			WORD *src = (WORD *)ssuf->pixels + ssuf->pitch * y/sizeof(WORD);
			SDL_PixelFormat *fmt = ssuf->format;
			for( int x=0; x < xx; x++ ){
				WORD dat = (((((*src)&fmt->Rmask)>>fmt->Rshift)<<fmt->Rloss)&0xf8) << 7 |
						   (((((*src)&fmt->Gmask)>>fmt->Gshift)<<fmt->Gloss)&0xf8) << 2 |
						   (((((*src)&fmt->Bmask)>>fmt->Bshift)<<fmt->Bloss)&0xf8) >> 3;
				FPUTWORD( dat, vfp );
				src++;
			}
		}
		break;
		
	case 24:	// 24bitξ
		for( int y = yy - 1; y >= 0; y-- ){
			BYTE *src = (BYTE *)ssuf->pixels + ssuf->pitch * y;
			for( int x=0; x < xx; x++ ){
				BYTE r,g,b;
				GET3BYTE( b, g, r, src );
				FPUTBYTE( b, vfp ); FPUTBYTE( g, vfp ); FPUTBYTE( r, vfp );
			}
		}
	}
	// ե졼1䤹
	vmh.dwTotalFrames++;
	
	// ǥ
	if( ABuf.ReadySize() > 0 ){
		anum += ABuf.ReadySize();
		FPUTDWORD( CID01WB, vfp );
		FPUTDWORD( ABuf.ReadySize()*2, vfp );
		while( ABuf.ReadySize() > 0 ){
			short dat = ABuf.Get();
			FPUTWORD( dat, vfp );
		}
	}
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ǥХåե
//
// :	ʤ
// :	cRing *		Хåե֥ȤؤΥݥ
////////////////////////////////////////////////////////////////
cRing *AVI6::GetAudioBuffer( void )
{
	return &ABuf;
}


////////////////////////////////////////////////////////////////
// إå󥯽Ф
//
// :	ʤ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL AVI6::WriteHeader( void )
{
	if( !vfp ) return FALSE;
	
	DWORD SIZESTRLV	= sizeof(AVISTRMHEADER6) + sizeof(BMPINFOHEADER6) + sizeof(DWORD)*5 + (ABPP==8 ? (sizeof(RGBPAL6)*256) : 0);
	DWORD SIZESTRLA	= sizeof(AVISTRMHEADER6) + sizeof(WAVEFORMATEX6)  + sizeof(DWORD)*5;
	DWORD SIZEHDRL  = SIZESTRLV + SIZESTRLA  + sizeof(MAINAVIHEADER6) + sizeof(DWORD)*7;
	DWORD SIZEJUNK  = 2048 - SIZEHDRL - sizeof(DWORD)*10;
	
	fseek( vfp, 0, SEEK_SET );
	
	fputs( "RIFF", vfp );
	FPUTDWORD( RiffSize, vfp );
		fputs( "AVI ", vfp );
			fputs( "LIST", vfp );
			FPUTDWORD( SIZEHDRL, vfp );
			fputs( "hdrl", vfp );
				fputs( "avih", vfp );
				FPUTDWORD( sizeof(MAINAVIHEADER6), vfp );
				putMAINAVIHEADER6( &vmh );
				
				// ӥǥ
				fputs( "LIST", vfp );
				FPUTDWORD( SIZESTRLV, vfp );
				fputs( "strl", vfp );
					fputs( "strh", vfp );
					FPUTDWORD( sizeof(AVISTRMHEADER6), vfp );
					putAVISTRMHEADER6( &vsh );
					
					fputs( "strf", vfp );
					switch( ABPP ){
					case 8:		// 8bitξ
						FPUTDWORD( sizeof(BMPINFOHEADER6) + sizeof(RGBPAL6)*256, vfp );
						putBMPINFOHEADER6( &vbf );
						fwrite( &pal, sizeof(BYTE), sizeof(RGBPAL6)*256, vfp );
						break;
						
					case 16:	// 16bitξ
					case 24:	// 24bitξ
						FPUTDWORD( sizeof(BMPINFOHEADER6), vfp );
						putBMPINFOHEADER6( &vbf );
					}
					
				// ǥ
				fputs( "LIST", vfp );
				FPUTDWORD( SIZESTRLA, vfp );
				fputs( "strl", vfp );
					fputs( "strh", vfp );
					FPUTDWORD( sizeof(AVISTRMHEADER6), vfp );
					putAVISTRMHEADER6( &ash );
					
					fputs( "strf", vfp );
					FPUTDWORD( sizeof(WAVEFORMATEX6), vfp );
					putWAVEFORMATEX6( &awf );
				
			fputs( "JUNK", vfp );
			FPUTDWORD( SIZEJUNK, vfp );
			for( DWORD i=0; i<SIZEJUNK; i++ ) FPUTBYTE( 0, vfp );
			
			fputs( "LIST", vfp );
			FPUTDWORD( MoviSize, vfp );
			
			PosMOVI = ftell( vfp );
			
			fputs( "movi", vfp );
	
	fseek( vfp, 0, SEEK_END );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ǥå󥯽Ф
//
// :	ʤ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL AVI6::WriteIndexr( void )
{
	if( !vfp ) return FALSE;
	
	DWORD frames = vmh.dwTotalFrames * 2;
	
	fseek( vfp, 0, SEEK_END );
	
	// ǥå󥯽
	fputs( "idx1", vfp );
	FPUTDWORD( sizeof(AVIINDEXENTRY6) * frames, vfp );
	DWORD ipos = 4;
	for( DWORD i=0; i<frames; i++ ){
		AVIINDEXENTRY6 idx;
		
		fseek( vfp, PosMOVI + ipos, SEEK_SET );
		idx.ckid          = FGETDWORD( vfp );
		if( idx.ckid == CID01WB ) idx.dwFlags = 0x00000000;
		else                      idx.dwFlags = 0x00000010;	// AVIIF_KEYFRAME
		idx.dwChunkOffset = ipos;
		idx.dwChunkLength = FGETDWORD( vfp );
		fseek( vfp, 0, SEEK_END );
		putAVIINDEXENTRY6( &idx );
		ipos += idx.dwChunkLength + 8;
	}
	
	return TRUE;
}
