#include "pd8255.h"
#include "mc6847.h"
#include "intr.h"
#include "memory.h"
#include "pd8049.h"


/*
BASIC ROM롼
								// 8049A˥ǡ
Z0323:	LD	A,0CH		;E78	// WIE(6)Lˤ Ĥޤ׵߶ػ INT=RINTȤ뤿?
		OUT	(093H),A	;E7A
								// ֤󤳤դΥߥ󥰤8049ǡϤSTB(4)=Lˤ롣
								// PortAϥå,ХåեΤIBF(5)=HȤʤ롣
								// ˤ8049ϥǡϤߤ,STB(4)=Hˤ롣
								// STB(4)Ω夬INT(3)=HȤʤ롣
								//  IBF(5)=H -> INT(3)=H νԤĤΤ?
Z0319:	IN	A,(092H)	;E7C
		AND	08H			;E7E	// INT(3)HˤʤޤԤ
		JR	Z,0E7CH		;E80	// Ĥޤ8049ΥǡPortA˥åޤԤ
		IN	A,(092H)	;E82
		AND	020H		;E84	// IBF(5)HˤʤޤԤ ¿ʬINT=HHˤʤäƤ
		JR	Z,0E7CH		;E86	// ĤޤPortAϥХåեޤԤ
		LD	A,0DH		;E88	// WIE(6)Hˤ Ĥޤ׵ߵ
		OUT	(093H),A	;E8A
		IN	A,(090H)	;E8C	// PortAǡ
		RET				;E8E
		
								// AΥǡ8049
Z0044:	PUSH	AF		;E8F
		LD	A,08H		;E90	// RIE(4)Lˤ Ĥޤɹ׵߶ػ INT=WINTȤ뤿?
		OUT	(093H),A	;E92
Z0320:	IN	A,(092H)	;E94
		AND	08H			;E96	// INT(3)HˤʤޤԤ
		JR	Z,0E94H		;E98	// Ĥޤ8049ǡäƥХåեˤʤޤԤ äǡ?
		IN	A,(092H)	;E9A
		AND	080H		;E9C	// OBF(7)HˤʤޤԤ ¿ʬINT=HHˤʤäƤ
		JR	Z,0E94H		;E9E	// Ĥޤ8049ǡäDAK=HˤʤޤԤ äǡ?
		LD	A,09H		;EA0	// RIE(4)Hˤ Ĥޤɹ׵ߵ
		OUT	(093H),A	;EA2
		POP	AF			;EA4
		OUT	(090H),A	;EA5	// PortA˥ǡ
		RET				;EA7


8255 ⡼2εư
bit3 INT()	[Ϥξ]νϤ8049ΥǡPortA()˥å줿ȤHȤʤ
				CPUФǡɹ׵߿ȤƯ
				[Ϥξ]νϤ8049ǡäHȤʤ,CPUФ
				Υǡν׵߿ȤƯ

bit4 STB()	ϤLˤ8049PortAƤ뿮PortAå
				[]IBFLˤʤSTBLˤʤȥݡåǡѲƤޤ
				STBIBFLˤʤޤǤHݤʤФʤʤ
				[­]8049~WR˷ҤäƤ餷Ĥޤ8049PortA˽Ϥ¨å롣

bit5 IBF()	νϤHλPortAϥХåեƤ뤳Ȥ̣,8049ФƥǡžζػߤΤ餻롣
				οSTBΩHȤʤSTB=1λΥǡɹ߽λ(~RDΩ夬)Lˤʤ롣
				⡼ľνͤLǤ롣

bit6 DAK()	Ϥ8049PortA()ΥǡäȤȤΤ餻뿮Ǥ롣
				ǡäLοФ褦8049߷פ롣
				[­]8049~RD˷ҤäƤ餷Ĥޤ8049PortAϤ¨DAK=Lˤʤ롣

bit7 OBF()	οCPUΥǡPortA()˥å줿LȤʤ,8049ФƤΥǡ׵ȤƯ
				OBFDAK=1ΤȤΥǡ߽λ(~WRΩ夬)Lˤʤ8049ǡäDAKΩHˤʤ롣
				⡼ľνͤHǤ롣
				[]OBFHˤʤ˥ǡνߤԤPortA()ѲƤޤΤ,OBFLδ֤Ͻߤ򤱤롣
				[­]8049INT˷ҤäƤ餷Ĥޤ8049ϳߤǥǡ롣


bit4 RIE		CPUФǡɹ׵ߤεĥե饰,ΥӥåȤӥå̿1ˤ뤳ȤˤäƳߵ,
				0ˤ뤳ȤˤäƳ߶ػߤˤ롣
				RIE񤭴ƤƱӥåȤ˳ƤƤSTBεǽˤϱƶͿʤ

bit6 WIE		CPUФǡ׵ߤεĥե饰,ΥӥåȤӥå̿1ˤ뤳ȤˤäƳߵ,
				0ˤ뤳ȤˤäƳ߶ػߤˤ롣
				WIE񤭴ƤƱӥåȤ˳ƤƤDAKεǽˤϱƶͿʤ
*/


// ϥɥӥå
#define	HS_INT	(0x08)	/* bit3 */
#define	HS_STB	(0x10)	/* bit4 */
#define	HS_IBF	(0x20)	/* bit5 */
#define	HS_DAK	(0x40)	/* bit6 */
#define	HS_OBF	(0x80)	/* bit7 */

#define	HS_RIE	(0x10)	/* bit4 */
#define	HS_WIE	(0x40)	/* bit6 */


////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
D8255::D8255( void )
{
	Reset();
}

PIO6::PIO6( VM6 *vm, const ID& id ) : P6DEVICE(vm,id), Device(id){}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
D8255::~D8255(){}
PIO6::~PIO6(){}


////////////////////////////////////////////////////////////////
// ꥻå
//
// :	ʤ
// :	ʤ
////////////////////////////////////////////////////////////////
void D8255::Reset( void )
{
	// н
	PortA    = PortB    = PortC     = 0;
	ModeA    = ModeB    = 0;
	PortAdir = PortBdir = PortC1dir = PortC2dir = TRUE;
	
	HSINT0 = HSWINT0 = HSRINT0 = HSIBF0 = FALSE;
	HSSTB0 = HSDAK0 = HSOBF0 = TRUE;
	RIE0   = WIE0 = FALSE;
}


////////////////////////////////////////////////////////////////
// ⡼
//
// :	data	ǡž
//				bit6,5: 롼AΥ⡼	1x:⡼2 01:⡼1 00:⡼0
//				bit4:   PortA				1:(ɤ) 0:()
//				bit3:   PortC(bit4-7)		1:(ɤ) 0:()
//				bit2:   롼BΥ⡼	1:⡼1 0:⡼0
//				bit1:   PortB				1:(ɤ) 0:()
//				bit0:   PortC(bit0-3)		1:(ɤ) 0:()
// :	ʤ
////////////////////////////////////////////////////////////////
void D8255::SetMode( BYTE data )
{
	ModeA     = (data>>6)&1 ? 2    : (data>>5)&1;
	ModeB     = (data>>2)&1;
	PortAdir  = (data>>4)&1 ? TRUE : FALSE;
	PortC2dir = (data>>3)&1 ? TRUE : FALSE;
	PortBdir  = (data>>1)&1 ? TRUE : FALSE;
	PortC1dir = (data   )&1 ? TRUE : FALSE;
	
	PortA = PortB = PortC = 0;
	if( ModeA == 2 ) PortC |= HS_OBF;
	
	PRINTD2( PPI_LOG, "[8255][SetMode] GrA:%d GrB:%d\n", ModeA, ModeB );
}


////////////////////////////////////////////////////////////////
// PartA 饤(¦)
//
// :	data	񤭹ǡ
// :	ʤ
////////////////////////////////////////////////////////////////
void D8255::WriteAE( BYTE data )
{
	PRINTD1( PPI_LOG, "[8255][WriteAE] %02X", data );
	
	// Ȥꤢ⡼2ξͤ
	if( ModeA == 2 ){
		// Хåե˥ǡå
		PortAbuf = data;
		// Ω
		if( HSSTB0 ){
			// IBF=H
			HSIBF0   = TRUE;
			
			PRINTD3( PPI_LOG, " DOWN IBF:%d RINT:%d DATA:%02X", HSIBF0 ? 1 : 0, HSRINT0 ? 1 : 0, data );
		}
		HSSTB0 = FALSE;
		// Ω
		if( !HSSTB0 ){
			// IBF=H ʤRINT=H
			if( HSIBF0 ) HSRINT0 = TRUE;
			
			PRINTD2( PPI_LOG, " UP IBF:%d RINT:%d", HSIBF0 ? 1 : 0, HSRINT0 ? 1 : 0 );
		}
		HSSTB0 = TRUE;
	}
	
	PRINTD( PPI_LOG, "\n" );
}


////////////////////////////////////////////////////////////////
// PartA ꡼(¦)
//
// :	ʤ
// :	BYTE	PortA
////////////////////////////////////////////////////////////////
BYTE D8255::ReadAE( void )
{
	PRINTD( PPI_LOG, "[8255][ReadAE]" );
	
	// Ȥꤢ⡼2ξͤ
	if( ModeA == 2 ){
		// ΩʤOBF=H
		if( HSDAK0 ){
			HSOBF0 = TRUE;
			
			PRINTD2( PPI_LOG, " DN OBF:%d WINT %d", HSOBF0 ? 1 : 0, HSWINT0 ? 1 : 0 );
		}
		HSDAK0 = FALSE;
		// Ω
		if( !HSDAK0 ){
			// OBF=H ʤWRINT=H
			if( HSOBF0 ) HSWINT0 = TRUE;
			
			PRINTD2( PPI_LOG, " UP OBF:%d WINT %d", HSOBF0 ? 1 : 0, HSWINT0 ? 1 : 0 );
		}
		HSDAK0 = TRUE;
	}
	
	PRINTD( PPI_LOG, "\n" );
	
	return PortA;
}


////////////////////////////////////////////////////////////////
// 
//
// :	ʤ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL D8255::Init( void )
{
	Reset();
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// PartA 饤
//
// :	data	񤭹ǡ
// :	ʤ
////////////////////////////////////////////////////////////////
void D8255::WriteA( BYTE data )
{
	PRINTD1( PPI_LOG, "[8255][WriteA] %02X", data );
	
	if( !PortAdir ){
		PortA = data;
		
		// Ȥꤢ⡼2ξͤ
		if( ModeA == 2 ){
			// WR0ΩWINT=L
			HSWINT0 = FALSE;
			// WR0Ω DAK=H ʤ OBF=L
			if( HSDAK0 ) HSOBF0 = FALSE;
			
			PRINTD2( PPI_LOG, " WINT:%d OBF %d\n", HSWINT0 ? 1 : 0, HSOBF0 ? 1 : 0 );
		}
		JobWriteA( PortA );
	}else{
		PRINTD( PPI_LOG, "\n" );
	}
}

void PIO6::JobWriteA( BYTE data )
{
	// ⡼2 DAK=H,OBF=L(ĤޤWR0Ω) ʤ8049ФƳ׵
	if( ModeA == 2 && HSDAK0 && !HSOBF0 )
		vm->subcpu->ExtIntr();
}


////////////////////////////////////////////////////////////////
// PartB 饤
//
// :	data	񤭹ǡ
// :	ʤ
////////////////////////////////////////////////////////////////
void D8255::WriteB( BYTE data )
{
	PRINTD1( PPI_LOG, "[8255][WriteB] %02X", data );
	
	if( !PortBdir ){
		PortB = data;
		JobWriteB( PortB );
	}
	
	PRINTD( PPI_LOG, "\n" );
}


////////////////////////////////////////////////////////////////
// PartC 饤
//
// :	data	񤭹ǡ
// :	ʤ
////////////////////////////////////////////////////////////////
void D8255::WriteC( BYTE data )
{
	PRINTD1( PPI_LOG, "[8255][WriteC] %02X", data );
	
	// ľܽߤϥ⡼0λˤΤ߲ǽ
	
	// 롼A⡼0  ä ̤bit0-3 ̤bit4-7
	//            ⡼1,2ä ̤bit0-2 ̤bit3-7
	
	
	if( ModeA == 0 ){
		// 롼A⡼0,롼B⡼1ä鲼(bit0-3)ޥ
		if( ModeB == 1 ) data = ( PortC & 0x0f ) | ( data & 0xf0 );
	}else{
		// 롼A⡼1,2ä(bit3-7)ޥ
		PortC = ( PortC & 0xf8 ) | ( data & 0x07 );
		// 롼A⡼1,2,롼B⡼1äƥޥ
		if( ModeB == 1 ) data = PortC;
	}
	
	// 
	if( !PortC1dir && ModeB == 0 ){
		if( ModeA == 0 ) PortC = ( PortC & 0xf0 ) | ( data & 0x0f );
		else             PortC = ( PortC & 0xf8 ) | ( data & 0x07 );
		JobWriteC1( PortC );
	}
	// 
	if( !PortC2dir && ModeA == 0 ){
		PortC = ( PortC & 0x07 ) | ( data & 0xf8 );
		JobWriteC2( PortC );
	}
	
	PRINTD( PPI_LOG, "\n" );
}

void PIO6::JobWriteC1( BYTE data )
{
	// ץ󥿥ȥ
	
	// CRTɽ
	vm->vdg->SetCrtDisp( data&2 ? TRUE : FALSE );
	
	// CG ROM BANK 
	vm->mem->SetCGBank( data&4 ? FALSE : TRUE );
}


////////////////////////////////////////////////////////////////
// PartD 饤(ȥݡ)
//
// :	data	񤭹ǡ
// :	ʤ
////////////////////////////////////////////////////////////////
void D8255::WriteD( BYTE data )
{
	PRINTD1( PPI_LOG, "[8255][WriteD] %02X", data );
	
	if( data&0x80 ){	// Ǿ̥ӥåȤ1ʤ
		// ⡼
		SetMode( data );
	}else{				// Ǿ̥ӥåȤ0ʤ
		// ӥåȥå/ꥻå
		// ⡼2оbitINT(bit3),IBF(bit5),OBF(bit7)ξ(ϥݡȤʤΤ)ޥ
		// ¾Υ⡼ɤϥΡ
		if( ModeA == 2 ){
			// bitб
			switch( (data>>1)&0x07 ){
			case 4: // RIE0
				RIE0 = ( data&1 ) ? TRUE : FALSE;
				break;
			
			case 6: // WIE0
				WIE0 = ( data&1 ) ? TRUE : FALSE;
				break;
			
			case 3: // INT0
			case 5: // IBF0
			case 7: // OBF0
				break;
			
			default:	// Ĥޤbit0-2
				if( data&1 ) PortC |=   1<<((data>>1)&0x07);
				else         PortC &= ~(1<<((data>>1)&0x07));
			}
		}else{
			if( data&1 ) PortC |=   1<<((data>>1)&0x07);
			else         PortC &= ~(1<<((data>>1)&0x07));
		}
		JobWriteD( data );
	}
	
	PRINTD( PPI_LOG, "\n" );
}

void PIO6::JobWriteD( BYTE data )
{
	// bitб
	switch( (data>>1)&0x07 ){
	case 0: // ץ󥿥ȥ
		break;
		
	case 1: // CRTɽ
		vm->vdg->SetCrtDisp( data&1 ? TRUE : FALSE );
		break;
		
	case 2: // CG ROM BANK 
		vm->mem->SetCGBank( data&1 ? FALSE : TRUE );
		break;
	}
}


////////////////////////////////////////////////////////////////
// PartA ꡼
//
// :	ʤ
// :	BYTE	PortA
////////////////////////////////////////////////////////////////
BYTE D8255::ReadA( void )
{
	// ϥݡȤǤ⤽Τޤɹ
	
	JobReadA();
	// Ȥꤢ⡼2ξͤ
	if( ModeA == 2 ){
		// RD0ΩRINT=L
		HSRINT0 = FALSE;
		
		// IBF=HʤХåեǡɹ
		if( HSIBF0 ){
			PortA = PortAbuf;
		}
		
		// RD0Ω STB=H ʤ IBF=L
		if( HSSTB0 ) HSIBF0 = FALSE;
	}
	
	PRINTD3( PPI_LOG, "[8255][Read][PortA] %02X STB:%d IBF:%d\n", PortA, HSSTB0, HSIBF0 );
	return PortA;
}


////////////////////////////////////////////////////////////////
// PartB ꡼
//
// :	ʤ
// :	BYTE	PortB
////////////////////////////////////////////////////////////////
BYTE D8255::ReadB( void )
{
	// ϥݡȤǤ⤽Τޤɹ
	
	JobReadB();
	return PortB;
}


////////////////////////////////////////////////////////////////
// PartC ꡼
//
// :	ʤ
// :	BYTE	PortC
////////////////////////////////////////////////////////////////
BYTE D8255::ReadC( void )
{
	// ϥݡȤǤ⤽Τޤɹ
	
	JobReadC();
	// Ȥꤢ⡼2ξͤ
	if( ModeA == 2 ){
		HSWINT0 = ( HSOBF0 && WIE0 && HSDAK0 ) ? TRUE : FALSE;
		HSRINT0 = ( HSIBF0 && RIE0 && HSSTB0 ) ? TRUE : FALSE;
		HSINT0  = ( HSWINT0 || HSRINT0 ) ? TRUE : FALSE;
		
		PortC = ( HSOBF0 ? HS_OBF : 0 ) | ( WIE0   ? HS_WIE : 0 ) | ( HSIBF0 ? HS_IBF : 0 ) |
				( RIE0   ? HS_RIE : 0 ) | ( HSINT0 ? HS_INT : 0 ) | ( PortC & 0x07 );
	}
	PRINTD5( PPI_LOG, "[8255][Read][PortC] OBF:%d WIE:%d IBF:%d RIE:%d INT:%d ", HSOBF0, WIE0, HSIBF0, RIE0, HSINT0  );
	PRINTD2( PPI_LOG, "WINT:%d RINT:%d\n", HSWINT0, HSRINT0 );
	return PortC;
}


////////////////////////////////////////////////////////////////
// IBF
//
// :	ʤ
// :	BOOL	ơ
////////////////////////////////////////////////////////////////
BOOL D8255::GetIBF( void )
{
	// Ȥꤢ⡼2ξͤ
	if( ModeA == 2 ) return HSIBF0;
	
	return FALSE;
}


////////////////////////////////////////////////////////////////
// OBF
//
// :	ʤ
// :	BOOL	ơ
////////////////////////////////////////////////////////////////
BOOL D8255::GetOBF( void )
{
	// Ȥꤢ⡼2ξͤ
	if( ModeA == 2 ) return HSOBF0;
	
	return FALSE;
}


////////////////////////////////////////////////////////////////
// ɤǤSAVE
//
// :	Ini		INI֥ȥݥ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL PIO6::DokoSave( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	Ini->PutEntry( "8255", NULL, "PortA",		"0x%02X",	PortA );
	Ini->PutEntry( "8255", NULL, "PortB",		"0x%02X",	PortB );
	Ini->PutEntry( "8255", NULL, "PortC",		"0x%02X",	PortC );
	Ini->PutEntry( "8255", NULL, "PortAbuf",	"0x%02X",	PortAbuf );
	Ini->PutEntry( "8255", NULL, "ModeA",		"%d",		ModeA );
	Ini->PutEntry( "8255", NULL, "ModeB",		"%d",		ModeB );
	Ini->PutEntry( "8255", NULL, "PortAdir",	"%s",		PortAdir ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "PortBdir",	"%s",		PortBdir ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "PortC1dir",	"%s",		PortC1dir ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "PortC2dir",	"%s",		PortC2dir ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "HSINT0",		"%s",		HSINT0 ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "HSWINT0",		"%s",		HSWINT0 ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "HSRINT0",		"%s",		HSRINT0 ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "HSSTB0",		"%s",		HSSTB0 ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "HSIBF0",		"%s",		HSIBF0 ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "HSDAK0",		"%s",		HSDAK0 ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "HSOBF0",		"%s",		HSOBF0 ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "RIE0",		"%s",		RIE0 ? "Yes" : "No" );
	Ini->PutEntry( "8255", NULL, "WIE0",		"%s",		WIE0 ? "Yes" : "No" );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ɤǤLOAD
//
// :	Ini		INI֥ȥݥ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL PIO6::DokoLoad( cIni *Ini )
{
	int st;
	
	if( !Ini ) return FALSE;
	
	Ini->GetInt(   "8255", "PortA",		&st,		PortA );	PortA = st;
	Ini->GetInt(   "8255", "PortB",		&st,		PortB );	PortB = st;
	Ini->GetInt(   "8255", "PortC",		&st,		PortC );	PortC = st;
	Ini->GetInt(   "8255", "PortAbuf",	&st,		PortAbuf );	PortAbuf = st;
	Ini->GetInt(   "8255", "ModeA",		&ModeA,		ModeA );
	Ini->GetInt(   "8255", "ModeA",		&ModeB,		ModeB );
	Ini->GetTruth( "8255", "PortAdir",	&PortAdir,	PortAdir );
	Ini->GetTruth( "8255", "PortBdir",	&PortBdir,	PortBdir );
	Ini->GetTruth( "8255", "PortC1dir",	&PortC1dir,	PortC1dir );
	Ini->GetTruth( "8255", "PortC2dir",	&PortC2dir,	PortC2dir );
	Ini->GetTruth( "8255", "HSINT0",	&HSINT0,	HSINT0 );
	Ini->GetTruth( "8255", "HSWINT0",	&HSWINT0,	HSWINT0 );
	Ini->GetTruth( "8255", "HSRINT0",	&HSRINT0,	HSRINT0 );
	Ini->GetTruth( "8255", "HSSTB0",	&HSSTB0,	HSSTB0 );
	Ini->GetTruth( "8255", "HSIBF0",	&HSIBF0,	HSIBF0 );
	Ini->GetTruth( "8255", "HSDAK0",	&HSDAK0,	HSDAK0 );
	Ini->GetTruth( "8255", "HSOBF0",	&HSOBF0,	HSOBF0 );
	Ini->GetTruth( "8255", "RIE0",		&RIE0,	RIE0 );
	Ini->GetTruth( "8255", "WIE0",		&WIE0,	WIE0 );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
//  device description
////////////////////////////////////////////////////////////////
const Device::Descriptor PIO6::descriptor = {
	PIO6::indef, PIO6::outdef
};

const Device::OutFuncPtr PIO6::outdef[] = {
	STATIC_CAST( Device::OutFuncPtr, &PIO6::Out90H ),
	STATIC_CAST( Device::OutFuncPtr, &PIO6::Out91H ),
	STATIC_CAST( Device::OutFuncPtr, &PIO6::Out92H ),
	STATIC_CAST( Device::OutFuncPtr, &PIO6::Out93H ),
	STATIC_CAST( Device::OutFuncPtr, &PIO6::OutPBH )
};

const Device::InFuncPtr PIO6::indef[] = {
	STATIC_CAST( Device::InFuncPtr, &PIO6::In90H ),
	STATIC_CAST( Device::InFuncPtr, &PIO6::In92H ),
	STATIC_CAST( Device::InFuncPtr, &PIO6::In93H ),
	STATIC_CAST( Device::InFuncPtr, &PIO6::InPBH ),
	STATIC_CAST( Device::InFuncPtr, &PIO6::InIBF ),
	STATIC_CAST( Device::InFuncPtr, &PIO6::InOBF )
};
