#ifndef SOUND_H_INCLUDED
#define SOUND_H_INCLUDED

#include "pc6001v.h"
#include "SCritical.h"


// ȥ꡼κ
// PSG + TAPE + VOICE = 3
#define	MAXSTREAM	(3)
// ХåեΨ
#define	MULTI		(2)

////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
// 󥰥Хåե֥
//   ŪˤϥMULTIܤ뤬гŪˤܤΤ褦˿
//   ɤ߽񤭤ΰФƹԤʤ뤬
//   ĤޤꥪСեɻߤĤĥ쥹ݥ󥹤ݤƤ...Ϥ
class cRing : public SCritical {
private:
	int *Buffer;			// ХåեؤΥݥ
	
	int Size;				// Хåե(ǡ)
	int Wpt;				// ߥݥ
	int Rpt;				// ɹߥݥ
	int Num;				// ̤ɥǡ
	
public:
	cRing();								// 󥹥ȥ饯
	~cRing();								// ǥȥ饯
	
	BOOL InitBuffer( int );					// Хåե
	
	int Get( int = -1 );					// ɹ
	BOOL Put( int );						// 
	
	int ReadySize();						// ̤ɥǡ
	int FreeSize();							// ĤХåե
	int GetSize();							// Хåե
};


// ɥǥХ֥
class SndDev : public cRing {
protected:
	int Volume;				// 
	
public:
	SndDev();								// 󥹥ȥ饯
	virtual ~SndDev();						// ǥȥ饯
	
	virtual void SetVolume( int );			// 
	virtual int SoundUpdate( int );			// ȥ꡼๹
};


// ɥ֥
class SND6 : public cRing {
private:
	SDL_AudioSpec ASpec;	// ǥڥå
	cRing *RB[MAXSTREAM];	// ȥ꡼ݥ
	int Volume;				// ޥ
	
public:
	SND6();									// 󥹥ȥ饯
	~SND6();								// ǥȥ饯
	
	BOOL Init( void *, void (*)(void *, Uint8 *, int ), int, int );	// 
	
	BOOL ConnectStream( cRing * );			// ȥ꡼³
	
	void Play();							// 
	void Pause();							// 
	
	int GetSampleRate();					// ץ󥰥졼ȼ
	void SetVolume( int );					// ޥ
	
	int PreUpdate( int, cRing * = NULL );	// ɻؿ
	void Update( Uint8 *, int );			// ɹؿ
};

#endif	// SOUND_H_INCLUDED
