#ifndef COMMON_H_INCLUDED
#define COMMON_H_INCLUDED

#ifdef __cplusplus
extern "C" {
#endif


#include "pc6001v.h"

////////////////////////////////////////////////////////////////
// ѷ׻ؿ
////////////////////////////////////////////////////////////////
DWORD CalcCrc32( BYTE *, int );						// CRC32׻


////////////////////////////////////////////////////////////////
// ʸؿ
////////////////////////////////////////////////////////////////
void Euc2Jis( BYTE *, BYTE * );						// EUC  -> JIS
//void Jis2Euc( BYTE *, BYTE * );						// JIS  -> EUC
//void Euc2Sjis( BYTE *, BYTE * );					// EUC  -> SJIS
//void Sjis2Euc( BYTE *, BYTE * );					// SJIS -> EUC
void Sjis2Jis( BYTE *, BYTE * );					// SJIS -> JIS
void Jis2Sjis( BYTE *, BYTE * );					// JIS  -> SJIS
void Convert2Jis( BYTE *, BYTE * );					// ʸɷѴ(SJIS,EUC -> JIS)

#ifdef __APPLE__
char *Sjis2UTF8( const char * );					// SJIS -> UTF8
#endif

int Sjis2P6( char *, char * );						// SJIS -> P6


////////////////////////////////////////////////////////////////
// SDLϢؿ
////////////////////////////////////////////////////////////////
void PSet( SDL_Surface *, int, int, BYTE );			// 
BYTE PGet( SDL_Surface *, int, int );				// 


////////////////////////////////////////////////////////////////
// PNGؿ
////////////////////////////////////////////////////////////////
void SavePNG( char *, SDL_Surface *, SDL_Rect * );	// PNG SAVE
SDL_Surface *LoadPNG( char * );						// PNG LOAD



#ifdef __cplusplus
}
#endif

#endif	// COMMON_H_INCLUDED
